Index: uspace/app/kio/kio.c
===================================================================
--- uspace/app/kio/kio.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/kio/kio.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -43,5 +43,5 @@
 #include <io/kio.h>
 #include <sysinfo.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <fibril_synch.h>
 #include <adt/list.h>
@@ -144,11 +144,9 @@
  * Receives kernel kio notifications.
  *
- * @param callid IPC call ID
  * @param call   IPC call structure
  * @param arg    Local argument
  *
  */
-static void kio_notification_handler(ipc_callid_t callid, ipc_call_t *call,
-    void *arg)
+static void kio_notification_handler(ipc_call_t *call, void *arg)
 {
 	/*
Index: uspace/app/mkbd/main.c
===================================================================
--- uspace/app/mkbd/main.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/mkbd/main.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -237,4 +237,6 @@
 	rc = devman_fun_get_path(dev_handle, path, MAX_PATH_LENGTH);
 	if (rc != EOK) {
+		printf(NAME ": failed to get path (handle %"
+		       PRIun "): %s.\n", dev_handle, str_error(errno));
 		return ENOMEM;
 	}
@@ -262,4 +264,5 @@
 	uint8_t *event = (uint8_t *)malloc(size);
 	if (event == NULL) {
+		printf("Out of memory.\n");
 		// TODO: hangup phone?
 		return ENOMEM;
Index: uspace/app/mkexfat/mkexfat.c
===================================================================
--- uspace/app/mkexfat/mkexfat.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/mkexfat/mkexfat.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -43,5 +43,5 @@
 #include <assert.h>
 #include <errno.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <byteorder.h>
 #include <align.h>
Index: uspace/app/modplay/modplay.c
===================================================================
--- uspace/app/modplay/modplay.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/modplay/modplay.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -40,4 +40,5 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <str_error.h>
 #include <trackmod.h>
 
@@ -117,5 +118,5 @@
 	rc = hound_context_connect_target(hound, HOUND_DEFAULT_TARGET);
 	if (rc != EOK) {
-		printf("Error connecting default audio target (%d).\n", rc);
+		printf("Error connecting default audio target: %s.\n", str_error(rc));
 		return 1;
 	}
Index: uspace/app/netstart/self_test.c
===================================================================
--- uspace/app/netstart/self_test.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/netstart/self_test.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -37,5 +37,5 @@
 
 #include <errno.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <stdio.h>
 
Index: uspace/app/nterm/conn.c
===================================================================
--- uspace/app/nterm/conn.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/nterm/conn.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -75,5 +75,5 @@
 		rc = tcp_conn_recv(conn, recv_buf, RECV_BUF_SIZE, &nrecv);
 		if (rc != EOK) {
-			printf("\n[Receive error %d]\n", rc);
+			printf("\n[Receive error: %s]\n", str_error_name(rc));
 			break;
 		}
Index: uspace/app/ping/ping.c
===================================================================
--- uspace/app/ping/ping.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/ping/ping.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -145,6 +145,6 @@
 	int rc = inetping_send(&sdu);
 	if (rc != EOK)
-		printf("Failed sending echo request: %s (%d).\n",
-		    str_error(rc), rc);
+		printf("Failed sending echo request: %s: %s.\n",
+		    str_error_name(rc), str_error(rc));
 	
 	return rc;
@@ -225,5 +225,5 @@
 	if (rc != EOK) {
 		printf("Failed connecting to internet ping service: "
-		    "%s (%d).\n", str_error(rc), rc);
+		    "%s: %s.\n", str_error_name(rc), str_error(rc));
 		goto error;
 	}
Index: uspace/app/rcutest/rcutest.c
===================================================================
--- uspace/app/rcutest/rcutest.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/rcutest/rcutest.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -38,4 +38,5 @@
 #include <stdlib.h>
 #include <stdint.h>
+#include <str_error.h>
 #include <mem.h>
 #include <errno.h>
@@ -780,5 +781,5 @@
 		int ret = thread_create(dummy_fibril, NULL, "urcu-test-worker", &tid);
 		if (EOK != ret) {
-			printf("Failed to create thread '%zu' (error: %d)\n", k + 1, ret);
+			printf("Failed to create thread '%zu' (error: %s)\n", k + 1, str_error_name(ret));
 			return false;
 		}
Index: uspace/app/redir/redir.c
===================================================================
--- uspace/app/redir/redir.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/redir/redir.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -59,12 +59,16 @@
 	*stream = NULL;
 	
-	int oldfd = vfs_lookup_open(path, WALK_REGULAR | flags, mode);
-	if (oldfd < 0)
+	int oldfd;
+	int rc = vfs_lookup_open(path, WALK_REGULAR | flags, mode, &oldfd);
+	if (rc != EOK)
 		return;
 	
 	if (oldfd != fd) {
-		if (vfs_clone(oldfd, fd, false) != fd)
+		int newfd;
+		if (vfs_clone(oldfd, fd, false, &newfd) != EOK)
 			return;
 		
+		assert(newfd == fd);
+
 		if (vfs_put(oldfd))
 			return;
Index: uspace/app/sportdmp/sportdmp.c
===================================================================
--- uspace/app/sportdmp/sportdmp.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/sportdmp/sportdmp.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -27,9 +27,10 @@
  */
 
-#include <char_dev_iface.h>
 #include <errno.h>
-#include <ipc/serial_ctl.h>
+#include <io/chardev.h>
+#include <io/serial.h>
 #include <loc.h>
 #include <stdio.h>
+#include <stdlib.h>
 
 #define BUF_SIZE 1
@@ -44,4 +45,7 @@
 	sysarg_t baud = 9600;
 	service_id_t svc_id;
+	chardev_t *chardev;
+	serial_t *serial;
+	size_t nread;
 
 	int arg = 1;
@@ -113,13 +117,22 @@
 	async_sess_t *sess = loc_service_connect(svc_id, INTERFACE_DDF,
 	    IPC_FLAG_BLOCKING);
-	if (!sess) {
+	if (sess == NULL) {
 		fprintf(stderr, "Failed connecting to service\n");
+		return 2;
 	}
 
-	async_exch_t *exch = async_exchange_begin(sess);
-	rc = async_req_4_0(exch, SERIAL_SET_COM_PROPS, baud,
-	    SERIAL_NO_PARITY, 8, 1);
-	async_exchange_end(exch);
+	rc = chardev_open(sess, &chardev);
+	if (rc != EOK) {
+		fprintf(stderr, "Failed opening character device\n");
+		return 2;
+	}
 
+	rc = serial_open(sess, &serial);
+	if (rc != EOK) {
+		fprintf(stderr, "Failed opening serial port\n");
+		return 2;
+	}
+
+	rc = serial_set_comm_props(serial, baud, SERIAL_NO_PARITY, 8, 1);
 	if (rc != EOK) {
 		fprintf(stderr, "Failed setting serial properties\n");
@@ -134,12 +147,11 @@
 
 	while (true) {
-		ssize_t read = char_dev_read(sess, buf, BUF_SIZE);
-		if (read < 0) {
-			fprintf(stderr, "Failed reading from serial device\n");
+		rc = chardev_read(chardev, buf, BUF_SIZE, &nread);
+		for (size_t i = 0; i < nread; i++) {
+			printf("%02hhx ", buf[i]);
+		}
+		if (rc != EOK) {
+			fprintf(stderr, "\nFailed reading from serial device\n");
 			break;
-		}
-		ssize_t i;
-		for (i = 0; i < read; i++) {
-			printf("%02hhx ", buf[i]);
 		}
 		fflush(stdout);
@@ -147,4 +159,7 @@
 
 	free(buf);
+	serial_close(serial);
+	chardev_close(chardev);
+	async_hangup(sess);
 	return 0;
 }
Index: uspace/app/stats/stats.c
===================================================================
--- uspace/app/stats/stats.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/stats/stats.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -42,5 +42,5 @@
 #include <errno.h>
 #include <stdlib.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <inttypes.h>
 #include <stdbool.h>
Index: uspace/app/sysinfo/sysinfo.c
===================================================================
--- uspace/app/sysinfo/sysinfo.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/sysinfo/sysinfo.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -39,5 +39,5 @@
 #include <stdint.h>
 #include <sysinfo.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 static void dump_bytes_hex(char *data, size_t size)
Index: uspace/app/sysinst/futil.c
===================================================================
--- uspace/app/sysinst/futil.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/sysinst/futil.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -57,5 +57,5 @@
 {
 	int sf, df;
-	ssize_t nr, nw;
+	size_t nr, nw;
 	int rc;
 	aoff64_t posr = 0, posw = 0;
@@ -63,31 +63,36 @@
 	printf("Copy '%s' to '%s'.\n", srcp, destp);
 
-	sf = vfs_lookup_open(srcp, WALK_REGULAR, MODE_READ);
-	if (sf < 0)
-		return EIO;
-
-	df = vfs_lookup_open(destp, WALK_REGULAR | WALK_MAY_CREATE, MODE_WRITE);
-	if (df < 0)
+	rc = vfs_lookup_open(srcp, WALK_REGULAR, MODE_READ, &sf);
+	if (rc != EOK)
+		return EIO;
+
+	rc = vfs_lookup_open(destp, WALK_REGULAR | WALK_MAY_CREATE, MODE_WRITE, &df);
+	if (rc != EOK)
 		return EIO;
 
 	do {
-		nr = vfs_read(sf, &posr, buf, BUF_SIZE);
+		rc = vfs_read(sf, &posr, buf, BUF_SIZE, &nr);
+		if (rc != EOK)
+			goto error;
 		if (nr == 0)
 			break;
-		if (nr < 0)
-			return EIO;
-
-		nw = vfs_write(df, &posw, buf, nr);
-		if (nw <= 0)
-			return EIO;
-	} while (true);
+
+		rc= vfs_write(df, &posw, buf, nr, &nw);
+		if (rc != EOK)
+			goto error;
+
+	} while (nr == BUF_SIZE);
 
 	(void) vfs_put(sf);
 
 	rc = vfs_put(df);
-	if (rc < 0)
+	if (rc != EOK)
 		return EIO;
 
 	return EOK;
+error:
+	vfs_put(sf);
+	vfs_put(df);
+	return rc;
 }
 
@@ -156,11 +161,12 @@
 {
 	int sf;
-	ssize_t nr;
+	size_t nr;
+	int rc;
 	size_t fsize;
 	char *data;
 	struct stat st;
 
-	sf = vfs_lookup_open(srcp, WALK_REGULAR, MODE_READ);
-	if (sf < 0)
+	rc = vfs_lookup_open(srcp, WALK_REGULAR, MODE_READ, &sf);
+	if (rc != EOK)
 		return ENOENT;
 
@@ -168,5 +174,5 @@
 		vfs_put(sf);
 		return EIO;
-	}	
+	}
 
 	fsize = st.size;
@@ -178,6 +184,6 @@
 	}
 
-	nr = vfs_read(sf, (aoff64_t []) { 0 }, data, fsize);
-	if (nr != (ssize_t)fsize) {
+	rc = vfs_read(sf, (aoff64_t []) { 0 }, data, fsize, &nr);
+	if (rc != EOK || nr != fsize) {
 		vfs_put(sf);
 		free(data);
Index: uspace/app/sysinst/sysinst.c
===================================================================
--- uspace/app/sysinst/sysinst.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/sysinst/sysinst.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -44,4 +44,5 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <str_error.h>
 #include <task.h>
 #include <vfs/vfs.h>
@@ -117,5 +118,5 @@
 	rc = fdisk_label_create(fdev, lt_mbr);
 	if (rc != EOK) {
-		printf("Error creating label (%d).\n", rc);
+		printf("Error creating label: %s.\n", str_error(rc));
 		return rc;
 	}
@@ -125,5 +126,5 @@
 	rc = fdisk_part_get_max_avail(fdev, spc_pri, &cap);
 	if (rc != EOK) {
-		printf("Error getting available capacity (%d).\n", rc);
+		printf("Error getting available capacity: %s.\n", str_error(rc));
 		return rc;
 	}
Index: uspace/app/taskdump/elf_core.c
===================================================================
--- uspace/app/taskdump/elf_core.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/taskdump/elf_core.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -55,4 +55,5 @@
 #include <stddef.h>
 #include <errno.h>
+#include <str_error.h>
 #include <mem.h>
 #include <as.h>
@@ -97,5 +98,6 @@
 
 	int fd;
-	ssize_t rc;
+	int rc;
+	size_t nwr;
 	unsigned int i;
 
@@ -122,8 +124,8 @@
 	}
 
-	fd = vfs_lookup_open(file_name, WALK_REGULAR | WALK_MAY_CREATE,
-	    MODE_WRITE);
-	if (fd < 0) {
-		printf("Failed opening file.\n");
+	rc = vfs_lookup_open(file_name, WALK_REGULAR | WALK_MAY_CREATE,
+	    MODE_WRITE, &fd);
+	if (rc != EOK) {
+		printf("Failed opening file '%s': %s.\n", file_name, str_error(rc));
 		free(p_hdr);
 		return ENOENT;
@@ -206,6 +208,6 @@
 	}
 
-	rc = vfs_write(fd, &pos, &elf_hdr, sizeof(elf_hdr));
-	if (rc != sizeof(elf_hdr)) {
+	rc = vfs_write(fd, &pos, &elf_hdr, sizeof(elf_hdr), &nwr);
+	if (rc != EOK) {
 		printf("Failed writing ELF header.\n");
 		free(p_hdr);
@@ -214,6 +216,6 @@
 
 	for (i = 0; i < n_ph; ++i) {
-		rc = vfs_write(fd, &pos, &p_hdr[i], sizeof(p_hdr[i]));
-		if (rc != sizeof(p_hdr[i])) {
+		rc = vfs_write(fd, &pos, &p_hdr[i], sizeof(p_hdr[i]), &nwr);
+		if (rc != EOK) {
 			printf("Failed writing program header.\n");
 			free(p_hdr);
@@ -231,6 +233,6 @@
 	note.type = NT_PRSTATUS;
 
-	rc = vfs_write(fd, &pos, &note, sizeof(elf_note_t));
-	if (rc != sizeof(elf_note_t)) {
+	rc = vfs_write(fd, &pos, &note, sizeof(elf_note_t), &nwr);
+	if (rc != EOK) {
 		printf("Failed writing note header.\n");
 		free(p_hdr);
@@ -238,6 +240,6 @@
 	}
 
-	rc = vfs_write(fd, &pos, "CORE", note.namesz);
-	if (rc != (ssize_t) note.namesz) {
+	rc = vfs_write(fd, &pos, "CORE", note.namesz, &nwr);
+	if (rc != EOK) {
 		printf("Failed writing note header.\n");
 		free(p_hdr);
@@ -247,6 +249,6 @@
 	pos = ALIGN_UP(pos, word_size);
 
-	rc = vfs_write(fd, &pos, &pr_status, sizeof(elf_prstatus_t));
-	if (rc != sizeof(elf_prstatus_t)) {
+	rc = vfs_write(fd, &pos, &pr_status, sizeof(elf_prstatus_t), &nwr);
+	if (rc != EOK) {
 		printf("Failed writing register data.\n");
 		free(p_hdr);
@@ -296,5 +298,6 @@
 	size_t total;
 	uintptr_t addr;
-	ssize_t rc;
+	int rc;
+	size_t nwr;
 
 	addr = area->start_addr;
@@ -309,6 +312,6 @@
 		}
 
-		rc = vfs_write(fd, pos, buffer, to_copy);
-		if (rc != (ssize_t) to_copy) {
+		rc = vfs_write(fd, pos, buffer, to_copy, &nwr);
+		if (rc != EOK) {
 			printf("Failed writing memory contents.\n");
 			return EIO;
Index: uspace/app/taskdump/symtab.c
===================================================================
--- uspace/app/taskdump/symtab.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/taskdump/symtab.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -41,4 +41,5 @@
 #include <stddef.h>
 #include <errno.h>
+#include <str_error.h>
 #include <vfs/vfs.h>
 
@@ -71,4 +72,5 @@
 	int fd;
 	int rc;
+	size_t nread;
 	int i;
 
@@ -81,13 +83,13 @@
 		return ENOMEM;
 
-	fd = vfs_lookup_open(file_name, WALK_REGULAR, MODE_READ);
-	if (fd < 0) {
-		printf("failed opening file\n");
+	rc = vfs_lookup_open(file_name, WALK_REGULAR, MODE_READ, &fd);
+	if (rc != EOK) {
+		printf("failed opening file '%s': %s\n", file_name, str_error(rc));
 		free(stab);
 		return ENOENT;
 	}
 
-	rc = vfs_read(fd, &pos, &elf_hdr, sizeof(elf_header_t));
-	if (rc != sizeof(elf_header_t)) {
+	rc = vfs_read(fd, &pos, &elf_hdr, sizeof(elf_header_t), &nread);
+	if (rc != EOK || nread != sizeof(elf_header_t)) {
 		printf("failed reading elf header\n");
 		free(stab);
@@ -304,8 +306,9 @@
 {
 	int rc;
+	size_t nread;
 	aoff64_t pos = elf_hdr->e_shoff + idx * sizeof(elf_section_header_t);
 
-	rc = vfs_read(fd, &pos, sec_hdr, sizeof(elf_section_header_t));
-	if (rc != sizeof(elf_section_header_t))
+	rc = vfs_read(fd, &pos, sec_hdr, sizeof(elf_section_header_t), &nread);
+	if (rc != EOK || nread != sizeof(elf_section_header_t))
 		return EIO;
 
@@ -326,5 +329,6 @@
 static int chunk_load(int fd, off64_t start, size_t size, void **ptr)
 {
-	ssize_t rc;
+	int rc;
+	size_t nread;
 	aoff64_t pos = start;
 
@@ -335,6 +339,6 @@
 	}
 
-	rc = vfs_read(fd, &pos, *ptr, size);
-	if (rc != (ssize_t) size) {
+	rc = vfs_read(fd, &pos, *ptr, size, &nread);
+	if (rc != EOK || nread != size) {
 		printf("failed reading chunk\n");
 		free(*ptr);
Index: uspace/app/taskdump/taskdump.c
===================================================================
--- uspace/app/taskdump/taskdump.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/taskdump/taskdump.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -40,4 +40,5 @@
 #include <stddef.h>
 #include <stdbool.h>
+#include <str_error.h>
 #include <errno.h>
 #include <udebug.h>
@@ -135,5 +136,5 @@
 		
 		printf("Error connecting\n");
-		printf("async_connect_kbox(%" PRIu64 ") -> %d ", task_id, errno);
+		printf("async_connect_kbox(%" PRIu64 ") -> %s", task_id, str_error_name(errno));
 		return errno;
 	}
@@ -141,5 +142,5 @@
 	int rc = udebug_begin(ksess);
 	if (rc < 0) {
-		printf("udebug_begin() -> %d\n", rc);
+		printf("udebug_begin() -> %s\n", str_error_name(rc));
 		return rc;
 	}
@@ -223,5 +224,5 @@
 	rc = udebug_thread_read(sess, &dummy_buf, 0, &copied, &needed);
 	if (rc < 0) {
-		printf("udebug_thread_read() -> %d\n", rc);
+		printf("udebug_thread_read() -> %s\n", str_error_name(rc));
 		return rc;
 	}
@@ -237,5 +238,5 @@
 	rc = udebug_thread_read(sess, thash_buf, buf_size, &copied, &needed);
 	if (rc < 0) {
-		printf("udebug_thread_read() -> %d\n", rc);
+		printf("udebug_thread_read() -> %s\n", str_error_name(rc));
 		return rc;
 	}
@@ -272,5 +273,5 @@
 	rc = udebug_areas_read(sess, &dummy_buf, 0, &copied, &needed);
 	if (rc < 0) {
-		printf("udebug_areas_read() -> %d\n", rc);
+		printf("udebug_areas_read() -> %s\n", str_error_name(rc));
 		return rc;
 	}
@@ -281,5 +282,5 @@
 	rc = udebug_areas_read(sess, ainfo_buf, buf_size, &copied, &needed);
 	if (rc < 0) {
-		printf("udebug_areas_read() -> %d\n", rc);
+		printf("udebug_areas_read() -> %s\n", str_error_name(rc));
 		return rc;
 	}
@@ -357,5 +358,5 @@
 	rc = udebug_regs_read(sess, thash, &istate);
 	if (rc < 0) {
-		printf("Failed reading registers (%d).\n", rc);
+		printf("Failed reading registers: %s.\n", str_error_name(rc));
 		return EIO;
 	}
Index: uspace/app/tester/Makefile
===================================================================
--- uspace/app/tester/Makefile	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/tester/Makefile	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -68,6 +68,6 @@
 	mm/mapping1.c \
 	mm/pager1.c \
-	hw/misc/virtchar1.c \
-	hw/serial/serial1.c
+	hw/serial/serial1.c \
+	chardev/chardev1.c
 
 include $(USPACE_PREFIX)/Makefile.common
Index: uspace/app/tester/chardev/chardev1.c
===================================================================
--- uspace/app/tester/chardev/chardev1.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
+++ uspace/app/tester/chardev/chardev1.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -0,0 +1,213 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <errno.h>
+#include <str_error.h>
+#include <ipc/services.h>
+#include <io/chardev.h>
+#include <loc.h>
+#include "../tester.h"
+
+#define SMALL_BUFFER_SIZE 64
+#define LARGE_BUFFER_SIZE (DATA_XFER_LIMIT * 4)
+
+static char small_buffer[SMALL_BUFFER_SIZE];
+static char large_buffer[LARGE_BUFFER_SIZE];
+
+/** Test device that always performs small transfers. */
+static const char *test_chardev1_smallx(void)
+{
+	chardev_t *chardev;
+	service_id_t sid;
+	async_sess_t *sess;
+	size_t nbytes;
+	int rc;
+
+	TPRINTF("Test small transfer character device operations\n");
+
+	rc = loc_service_get_id(SERVICE_NAME_CHARDEV_TEST_SMALLX, &sid, 0);
+	if (rc != EOK) {
+		return "Failed resolving test device "
+		    SERVICE_NAME_CHARDEV_TEST_SMALLX;
+	}
+
+	sess = loc_service_connect(sid, INTERFACE_DDF, 0);
+	if (sess == NULL)
+		return "Failed connecting test device";
+
+	rc = chardev_open(sess, &chardev);
+	if (rc != EOK) {
+		async_hangup(sess);
+		return "Failed opening test device";
+	}
+
+	rc = chardev_write(chardev, small_buffer, SMALL_BUFFER_SIZE, &nbytes);
+	if (rc != EOK) {
+		chardev_close(chardev);
+		async_hangup(sess);
+		return "Failed sending data";
+	}
+
+	TPRINTF("Sent %zu bytes\n", nbytes);
+
+	rc = chardev_read(chardev, small_buffer, SMALL_BUFFER_SIZE, &nbytes);
+	if (rc != EOK) {
+		chardev_close(chardev);
+		async_hangup(sess);
+		return "Failed receiving data";
+	}
+
+	TPRINTF("Received %zu bytes\n", nbytes);
+
+	chardev_close(chardev);
+	async_hangup(sess);
+
+	TPRINTF("Done\n");
+	return NULL;
+}
+
+/** Test device that always performs large transfers. */
+static const char *test_chardev1_largex(void)
+{
+	chardev_t *chardev;
+	service_id_t sid;
+	async_sess_t *sess;
+	size_t nbytes;
+	int rc;
+
+	TPRINTF("Test large transfer character device operations\n");
+
+	rc = loc_service_get_id(SERVICE_NAME_CHARDEV_TEST_LARGEX, &sid, 0);
+	if (rc != EOK) {
+		return "Failed resolving test device "
+		    SERVICE_NAME_CHARDEV_TEST_LARGEX;
+	}
+
+	sess = loc_service_connect(sid, INTERFACE_DDF, 0);
+	if (sess == NULL)
+		return "Failed connecting test device";
+
+	rc = chardev_open(sess, &chardev);
+	if (rc != EOK) {
+		async_hangup(sess);
+		return "Failed opening test device";
+	}
+
+	rc = chardev_write(chardev, large_buffer, LARGE_BUFFER_SIZE, &nbytes);
+	if (rc != EOK) {
+		chardev_close(chardev);
+		async_hangup(sess);
+		return "Failed sending data";
+	}
+
+	TPRINTF("Sent %zu bytes\n", nbytes);
+
+	rc = chardev_read(chardev, large_buffer, LARGE_BUFFER_SIZE, &nbytes);
+	if (rc != EOK) {
+		chardev_close(chardev);
+		async_hangup(sess);
+		return "Failed receiving data";
+	}
+
+	TPRINTF("Received %zu bytes\n", nbytes);
+
+	chardev_close(chardev);
+	async_hangup(sess);
+
+	TPRINTF("Done\n");
+	return NULL;
+}
+
+/** Test device where all transfers return partial success. */
+static const char *test_chardev1_partialx(void)
+{
+	chardev_t *chardev;
+	service_id_t sid;
+	async_sess_t *sess;
+	size_t nbytes;
+	int rc;
+
+	TPRINTF("Test partially-successful character device operations\n");
+
+	rc = loc_service_get_id(SERVICE_NAME_CHARDEV_TEST_PARTIALX, &sid, 0);
+	if (rc != EOK) {
+		return "Failed resolving test device "
+		    SERVICE_NAME_CHARDEV_TEST_SMALLX;
+	}
+
+	sess = loc_service_connect(sid, INTERFACE_DDF, 0);
+	if (sess == NULL)
+		return "Failed connecting test device";
+
+	rc = chardev_open(sess, &chardev);
+	if (rc != EOK) {
+		async_hangup(sess);
+		return "Failed opening test device";
+	}
+
+	rc = chardev_write(chardev, small_buffer, SMALL_BUFFER_SIZE, &nbytes);
+	if (rc != EIO || nbytes != 1) {
+		chardev_close(chardev);
+		async_hangup(sess);
+		return "Failed sending data";
+	}
+
+	TPRINTF("Sent %zu bytes and got rc = %s (expected)\n", nbytes,
+	    str_error_name(rc));
+
+	rc = chardev_read(chardev, small_buffer, SMALL_BUFFER_SIZE, &nbytes);
+	if (rc != EIO || nbytes != 1) {
+		chardev_close(chardev);
+		async_hangup(sess);
+		return "Failed receiving data";
+	}
+
+	TPRINTF("Received %zu bytes and got rc = %s (expected)\n", nbytes,
+	    str_error_name(rc));
+
+	chardev_close(chardev);
+	async_hangup(sess);
+
+	TPRINTF("Done\n");
+	return NULL;
+}
+
+const char *test_chardev1(void)
+{
+	const char *s;
+
+	s = test_chardev1_smallx();
+	if (s != NULL)
+		return s;
+
+	s = test_chardev1_largex();
+	if (s != NULL)
+		return s;
+
+	return test_chardev1_partialx();;
+}
Index: uspace/app/tester/chardev/chardev1.def
===================================================================
--- uspace/app/tester/chardev/chardev1.def	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
+++ uspace/app/tester/chardev/chardev1.def	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -0,0 +1,6 @@
+{
+	"chardev1",
+	"Character device basic functionality",
+	&test_chardev1,
+	false
+},
Index: uspace/app/tester/hw/serial/serial1.c
===================================================================
--- uspace/app/tester/hw/serial/serial1.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/tester/hw/serial/serial1.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,16 +35,14 @@
  */
 
-#include <inttypes.h>
+#include <async.h>
 #include <errno.h>
+#include <io/chardev.h>
+#include <io/serial.h>
+#include <ipc/services.h>
+#include <loc.h>
 #include <stdlib.h>
 #include <stdio.h>
 #include <stddef.h>
-#include <async.h>
-#include <thread.h>
-#include <ipc/services.h>
-#include <loc.h>
-#include <char_dev_iface.h>
 #include <str.h>
-#include <ipc/serial_ctl.h>
 #include "../../tester.h"
 
@@ -56,4 +54,9 @@
 {
 	size_t cnt;
+	serial_t *serial;
+	chardev_t *chardev;
+	int rc;
+	size_t nread;
+	size_t nwritten;
 	
 	if (test_argc < 1)
@@ -79,36 +82,48 @@
 	async_sess_t *sess = loc_service_connect(svc_id, INTERFACE_DDF,
 	    IPC_FLAG_BLOCKING);
-	if (!sess)
+	if (sess == NULL)
 		return "Failed connecting to serial device";
+	
+	res = chardev_open(sess, &chardev);
+	if (res != EOK) {
+		async_hangup(sess);
+		return "Failed opening serial port";
+	}
+	
+	res = serial_open(sess, &serial);
+	if (res != EOK) {
+		chardev_close(chardev);
+		async_hangup(sess);
+		return "Failed opening serial port";
+	}
 	
 	char *buf = (char *) malloc(cnt + 1);
 	if (buf == NULL) {
+		chardev_close(chardev);
+		serial_close(serial);
 		async_hangup(sess);
 		return "Failed allocating input buffer";
 	}
 	
-	sysarg_t old_baud;
-	sysarg_t old_par;
-	sysarg_t old_stop;
-	sysarg_t old_word_size;
-	
-	async_exch_t *exch = async_exchange_begin(sess);
-	res = async_req_0_4(exch, SERIAL_GET_COM_PROPS, &old_baud,
-	    &old_par, &old_word_size, &old_stop);
-	async_exchange_end(exch);
-	
+	unsigned old_baud;
+	serial_parity_t old_par;
+	unsigned old_stop;
+	unsigned old_word_size;
+	
+	res = serial_get_comm_props(serial, &old_baud, &old_par,
+	    &old_word_size, &old_stop);
 	if (res != EOK) {
 		free(buf);
+		chardev_close(chardev);
+		serial_close(serial);
 		async_hangup(sess);
 		return "Failed to get old serial communication parameters";
 	}
 	
-	exch = async_exchange_begin(sess);
-	res = async_req_4_0(exch, SERIAL_SET_COM_PROPS, 1200,
-	    SERIAL_NO_PARITY, 8, 1);
-	async_exchange_end(exch);
-	
+	res = serial_set_comm_props(serial, 1200, SERIAL_NO_PARITY, 8, 1);
 	if (EOK != res) {
 		free(buf);
+		chardev_close(chardev);
+		serial_close(serial);
 		async_hangup(sess);
 		return "Failed setting serial communication parameters";
@@ -120,67 +135,62 @@
 	size_t total = 0;
 	while (total < cnt) {
-		ssize_t read = char_dev_read(sess, buf, cnt - total);
-		
-		if (read < 0) {
-			exch = async_exchange_begin(sess);
-			async_req_4_0(exch, SERIAL_SET_COM_PROPS, old_baud,
-			    old_par, old_word_size, old_stop);
-			async_exchange_end(exch);
-			
-			free(buf);
+		
+		rc = chardev_read(chardev, buf, cnt - total, &nread);
+		if (rc != EOK) {
+			(void) serial_set_comm_props(serial, old_baud,
+			    old_par, old_word_size, old_stop);
+			
+			free(buf);
+			chardev_close(chardev);
+			serial_close(serial);
 			async_hangup(sess);
 			return "Failed reading from serial device";
 		}
 		
-		if ((size_t) read > cnt - total) {
-			exch = async_exchange_begin(sess);
-			async_req_4_0(exch, SERIAL_SET_COM_PROPS, old_baud,
-			    old_par, old_word_size, old_stop);
-			async_exchange_end(exch);
-			
-			free(buf);
+		if (nread > cnt - total) {
+			(void) serial_set_comm_props(serial, old_baud,
+			    old_par, old_word_size, old_stop);
+			
+			free(buf);
+			chardev_close(chardev);
+			serial_close(serial);
 			async_hangup(sess);
 			return "Read more data than expected";
 		}
 		
-		TPRINTF("Read %zd bytes\n", read);
-		
-		if (read == 0)
-			thread_usleep(DEFAULT_SLEEP);
-		else {
-			buf[read] = 0;
-			
-			/*
-			 * Write data back to the device to test the opposite
-			 * direction of data transfer.
-			 */
-			ssize_t written = char_dev_write(sess, buf, read);
-			
-			if (written < 0) {
-				exch = async_exchange_begin(sess);
-				async_req_4_0(exch, SERIAL_SET_COM_PROPS, old_baud,
-				    old_par, old_word_size, old_stop);
-				async_exchange_end(exch);
-				
-				free(buf);
-				async_hangup(sess);
-				return "Failed writing to serial device";
-			}
-			
-			if (written != read) {
-				exch = async_exchange_begin(sess);
-				async_req_4_0(exch, SERIAL_SET_COM_PROPS, old_baud,
-				    old_par, old_word_size, old_stop);
-				async_exchange_end(exch);
-				
-				free(buf);
-				async_hangup(sess);
-				return "Written less data than read from serial device";
-			}
-			
-			TPRINTF("Written %zd bytes\n", written);
-		}
-		
-		total += read;
+		TPRINTF("Read %zd bytes\n", nread);
+		
+		buf[nread] = 0;
+		
+		/*
+		 * Write data back to the device to test the opposite
+		 * direction of data transfer.
+		 */
+		rc = chardev_write(chardev, buf, nread, &nwritten);
+		if (rc != EOK) {
+			(void) serial_set_comm_props(serial, old_baud,
+			    old_par, old_word_size, old_stop);
+			
+			free(buf);
+			chardev_close(chardev);
+			serial_close(serial);
+			async_hangup(sess);
+			return "Failed writing to serial device";
+		}
+		
+		if (nwritten != nread) {
+			(void) serial_set_comm_props(serial, old_baud,
+			    old_par, old_word_size, old_stop);
+			
+			free(buf);
+			chardev_close(chardev);
+			serial_close(serial);
+			async_hangup(sess);
+			return "Written less data than read from serial device";
+		}
+		
+		TPRINTF("Written %zd bytes\n", nwritten);
+		
+		total += nread;
 	}
 	
@@ -188,18 +198,18 @@
 	
 	size_t eot_size = str_size(EOT);
-	ssize_t written = char_dev_write(sess, (void *) EOT, eot_size);
-	
-	exch = async_exchange_begin(sess);
-	async_req_4_0(exch, SERIAL_SET_COM_PROPS, old_baud,
-	    old_par, old_word_size, old_stop);
-	async_exchange_end(exch);
+	rc = chardev_write(chardev, (void *) EOT, eot_size, &nwritten);
+	
+	(void) serial_set_comm_props(serial, old_baud, old_par, old_word_size,
+	    old_stop);
 	
 	free(buf);
+	chardev_close(chardev);
+	serial_close(serial);
 	async_hangup(sess);
 	
-	if (written < 0)
+	if (rc != EOK)
 		return "Failed to write EOT banner to serial device";
 	
-	if ((size_t) written != eot_size)
+	if (nwritten != eot_size)
 		return "Written less data than the size of the EOT banner "
 		    "to serial device";
Index: uspace/app/tester/mm/common.c
===================================================================
--- uspace/app/tester/mm/common.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/tester/mm/common.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -29,5 +29,5 @@
  */
 
-#include <malloc.h>
+#include <stdlib.h>
 #include <as.h>
 #include <adt/list.h>
Index: uspace/app/tester/mm/malloc2.c
===================================================================
--- uspace/app/tester/mm/malloc2.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/tester/mm/malloc2.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -30,5 +30,4 @@
 #include <stdlib.h>
 #include <stddef.h>
-#include <malloc.h>
 #include "../tester.h"
 
